#include<bits/stdc++.h>
#define int long long
using namespace std;

signed main() {
    int n;
    cin>>n;
    vector<int>a(n),b(n);
    for(int i=0;i<n;++i)
        cin>>a[i];
    bool jed=1;
    for(int i=0;i<n;++i){
        cin>>b[i];
        if(b[i]!=1) 
            jed=0;
    }
    if(!jed){
        cout<<"nz\n";
        return 0;
    }
    vector<int>dp(n);
    dp[0]=0;
    for (int i=1;i<n;++i) 
        dp[i]=(dp[i-1]^a[i]);
    
    int tr=0,mx=0,m=dp.size();
    for(int i=30;~i;--i){
        tr|=(1<<i);
        set<int>s;
        int k;
        for(int j=0;j<m;++j) 
            s.insert(dp[j]&tr);

        k=mx|(1<<i);
        for(auto&e:s){
            if(s.count(k^e)){
                mx=k;
                break;
            }
        }
    }
    cout<<mx<<'\n';
}